(ns com.aurellem.run.sound
  (:use (com.aurellem.gb saves gb-driver util constants
                         items vbm characters money
                         rlm-assembly))
  (:use (com.aurellem.run util music title save-corruption
                          bootstrap-0 bootstrap-1))
  (:require clojure.string)
  (:import [com.aurellem.gb.gb_driver SaveState])
  (:import java.awt.image.BufferedImage)
  (:import java.io.File)
  (:import com.aurellem.gb.WaveWriter))

(defn sound-test []
  (step (mid-game))
  (println (frequencies (sound-bytes)))
  (run-moves @current-state (repeat 10 []))
  (println (frequencies (sound-bytes))))

(defn record-sound!
  ([^File target-file state n]
     (set-state! state)
     (let [writer (WaveWriter. target-file)]
       (dorun
        (for [y (range n)]
          (do (step)
              (.process writer
                        (sound-bytes)
                        gb-sound-format))))
       (.cleanup writer)
       (Thread/sleep 1000)
       (clojure.java.shell/sh
        "aplay"
        (.getCanonicalPath target-file))))
  ([n] (record-sound!
        (File. "/home/r/proj/vba-clojure/sounds/test-sound.wav")
        (play-midi pony-csv) n)))

(defn gen-pony! []
  (record-sound!
   (File. user-home "proj/vba-clojure/sounds/pony.wav")
   (play-midi pony-csv)
   1800))

(defn gen-regret! []
  (record-sound!
   (File. user-home "proj/vba-clojure/sounds/regret.wav")
   (play-midi regret-csv)
   3380))

(defn gen-mother! []
  (record-sound!
   (File. user-home "proj/vba-clojure/sounds/mother.wav")
   (play-midi mother-csv)
   2200))


